Index: /LMDZ4/branches/LMDZ4_par_0/libf/dyn3d/gcm.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/dyn3d/gcm.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/dyn3d/gcm.F	(revision 634)
@@ -9,4 +9,7 @@
       USE IOIPSL
 #endif
+
+      USE dimphy
+      USE comgeomphy
 
       IMPLICIT NONE
@@ -188,4 +191,10 @@
 c
 c
+c------------------------------------
+c   Initialisation partie parallele
+c------------------------------------
+      call InitDimphy
+      call InitComgeomphy
+
 c-----------------------------------------------------------------------
 c   Initialisation des traceurs
Index: /LMDZ4/branches/LMDZ4_par_0/libf/dyn3d/paramet.h
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/dyn3d/paramet.h	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/dyn3d/paramet.h	(revision 634)
@@ -10,6 +10,6 @@
       INTEGER jcfil,jcfllm
 
-      PARAMETER( iip1= iim+1-1/iim,iip2=iim+2,iip3=iim+3
-     s    ,jjp1=jjm+1-1/jjm)
+      PARAMETER( iip1= iim+1-1/iim,iip2=iim+2,iip3=iim+3)
+      PARAMETER( jjp1=jjm+1-1/jjm)
       PARAMETER( llmp1 = llm+1,  llmp2 = llm+2, llmm1 = llm-1 )
       PARAMETER( kftd  = iim/2 -ndm )
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/aeropt.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/aeropt.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/aeropt.F	(revision 634)
@@ -5,10 +5,11 @@
      .            tau_ae, piz_ae, cg_ae, ai        )
 c
+      USE dimphy
       IMPLICIT none
 c
 c
 c     
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ajsec.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ajsec.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ajsec.F	(revision 634)
@@ -3,4 +3,5 @@
 !
       SUBROUTINE ajsec(paprs, pplay, t,q, d_t,d_q)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -13,6 +14,6 @@
 c d_t-----output-R-Incrementation de la temperature
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
       REAL paprs(klon,klev+1), pplay(klon,klev)
@@ -22,5 +23,5 @@
       INTEGER limbas, limhau ! les couches a ajuster
 ccc      PARAMETER (limbas=klev-3, limhau=klev)
-      PARAMETER (limbas=1, limhau=klev)
+cym      PARAMETER (limbas=1, limhau=klev)
 c
       LOGICAL mixq
@@ -38,4 +39,8 @@
 c Initialisation:
 c
+cym
+      limbas=1
+      limhau=klev
+  
       DO k = 1, klev
       DO i = 1, klon
@@ -149,4 +154,5 @@
       END
       SUBROUTINE ajsec_old(paprs, pplay, t, d_t)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -159,6 +165,6 @@
 c d_t-----output-R-Incrementation de la temperature
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
       REAL paprs(klon,klev+1), pplay(klon,klev)
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/albedo.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/albedo.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/albedo.F	(revision 634)
@@ -5,4 +5,5 @@
 c
       SUBROUTINE alboc(rjour,rlat,albedo)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -17,6 +18,6 @@
 c albedo (out,R): albedo obtenu (de 0 a 1)
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -127,4 +128,5 @@
 c=====================================================================
       SUBROUTINE alboc_cd(rmu0,albedo)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -140,6 +142,6 @@
 c albedo (out): albedo de surface de l'ocean
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
       REAL rmu0(klon), albedo(klon)
 c
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/calcratqs.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/calcratqs.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/calcratqs.F	(revision 634)
@@ -5,4 +5,5 @@
      I            paprs,pplay,q_seri,d_t_con,d_t_ajs
      O           ,ratqs,zpt_conv)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -23,6 +24,6 @@
 c pplay---input-R-pression pour le mileu de chaque couche (en Pa)
 c presnivs-input_R_pressions approximat. des milieux couches ( en PA)
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
       REAL paprs(klon,klev+1)
       REAL pplay(klon,klev)
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/calltherm.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/calltherm.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/calltherm.F	(revision 634)
@@ -8,7 +8,8 @@
      s      ,fm_therm,entr_therm)
 
+      USE dimphy
       implicit none
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "thermcell.h"
 
@@ -35,7 +36,9 @@
       REAL d_u_the(klon,klev),d_v_the(klon,klev)
 c
-      real zfm_therm(klon,klev+1),zentr_therm(klon,klev),zdt
-      save zentr_therm,zfm_therm
-
+cym      real zfm_therm(klon,klev+1),zentr_therm(klon,klev),zdt
+cym      save zentr_therm,zfm_therm
+      real,allocatable,dimension(:,:),save :: zfm_therm,zentr_therm
+      real :: zdt
+      logical,save :: first=.true.
       integer i,k
 
@@ -47,5 +50,12 @@
        print*,'avant isplit ',nsplit_thermals
 
-
+cym initialisation dynamique
+         if (first) then
+	   allocate(zfm_therm(klon,klev+1),zentr_therm(klon,klev))
+	   zfm_therm(:,:)=0.
+	   zentr_therm(:,:)=0.
+	   first=.false.
+	 endif
+	 
          fm_therm(:,:)=0.
          entr_therm(:,:)=0.
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/clmain.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/clmain.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/clmain.F	(revision 634)
@@ -4,4 +4,6 @@
 c
 c
+#define IO_DISCONNECTED
+
       SUBROUTINE clmain(dtime,itap,date0,pctsrf,pctsrf_new,
      .                  t,q,u,v,
@@ -39,4 +41,5 @@
       USE ioipsl
       USE interface_surf
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -83,6 +86,6 @@
 c d_tr-------output-R tendance de traceurs
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "indicesol.h"
 c$$$ PB ajout pour soil
@@ -225,8 +228,10 @@
       INTEGER nhoridbg, nidbg
       SAVE nhoridbg, nidbg
+#ifndef IO_DISCONNECTED
       INTEGER ndexbg(iim*(jjm+1))
       REAL zx_lon(iim,jjm+1), zx_lat(iim,jjm+1), zjulian
       REAL tabindx(klon)
       REAL debugtab(iim,jjm+1)
+#endif
       LOGICAL first_appel
       SAVE first_appel
@@ -274,4 +279,5 @@
 ! initialisation sorties netcdf
 !
+#ifndef IO_DISCONNECTED
           idayref = day_ini
           CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
@@ -297,4 +303,5 @@
           CALL histend(nidbg)
           CALL histsync(nidbg)
+#endif
       ENDIF 
           
@@ -430,4 +437,5 @@
 c variables pour avoir une sortie IOIPSL des INDEX
 c
+#ifndef IO_DISCONNECTED
       IF (debugindex) THEN 
           tabindx(:)=0.
@@ -442,4 +450,8 @@
      $        ,ndexbg)
       ENDIF 
+#endif
+
+      fluxlat(:,nsrf) = 0.
+      
       IF (knon.EQ.0) GOTO 99999
       DO j = 1, knon
@@ -927,5 +939,5 @@
 
       USE interface_surf
-
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -934,5 +946,5 @@
 c======================================================================
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1203,4 +1215,6 @@
       ccanopy = co2_ppm
 
+!      if (monocpu) then
+
       CALL interfsurf(itime, dtime, date0, jour, rmu0,
      e klon, iim, jjm, nisurf, knon, knindex, pctsrf, 
@@ -1222,4 +1236,10 @@
      s pctsrf_new, agesno,fqcalving,ffonte, run_off_lic_0)
 
+!      else
+        
+!	STOP 'clmain : interfsurf n est pas encore parallelise => abort'
+	
+!      endif
+      
 
       do i = 1, knon
@@ -1268,4 +1288,5 @@
      e                  paprs,pplay,delp,
      s                  d_ven,flux_v)
+      use dimphy
       IMPLICIT none
 c======================================================================
@@ -1290,6 +1311,6 @@
 c flux_v---output-R- (diagnostic) flux du vent: (kg m/s)/(m**2 s)
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "iniprint.h"
       INTEGER knon
@@ -1393,4 +1414,5 @@
      .                  qsurf, 
      .                  pcfm, pcfh)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1415,6 +1437,6 @@
 c pcfh-----output-R- coefficients a calculer (chaleur et humidite)
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "indicesol.h"
@@ -1462,5 +1484,5 @@
       PARAMETER (mixlen=35.0)
       INTEGER isommet ! le sommet de la couche limite
-      PARAMETER (isommet=klev)
+cym      PARAMETER (isommet=klev)
       LOGICAL tvirtu ! calculer Ri d'une maniere plus performante
       PARAMETER (tvirtu=.TRUE.)
@@ -1510,4 +1532,7 @@
       DATA appel1er /.TRUE./
 c
+cym
+      isommet=klev
+      
       IF (appel1er) THEN
         if (prt_level > 9) THEN
@@ -1713,4 +1738,5 @@
       SUBROUTINE coefkz2(nsrf, knon, paprs, pplay,t,
      .                  pcfm, pcfh)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1729,6 +1755,6 @@
 c pcfh-----output-R- coefficients a calculer (chaleur et humidite)
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "indicesol.h"
@@ -1816,4 +1842,5 @@
       SUBROUTINE calbeta(dtime,indice,knon,snow,qsol,
      .                    vbeta,vcal,vdif)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1824,6 +1851,6 @@
 c Calculer quelques parametres pour appliquer la couche limite
 c ------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "indicesol.h"
@@ -1893,4 +1920,5 @@
      .                    tsol,beta,u,v,t,q,
      .                    cd_h, cd_m, pcfh, pcfm, cgh, cgq)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1907,6 +1935,6 @@
 c model. J. of Climate, vol. 6, 1825-1842.
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "iniprint.h"
@@ -1927,5 +1955,5 @@
 c
       INTEGER isommet
-      PARAMETER (isommet=klev)
+cym      PARAMETER (isommet=klev)
       REAL vk
       PARAMETER (vk=0.40)
@@ -2003,4 +2031,7 @@
 c Initialisation
 c
+cym
+      isommet=klev
+
       DO i = 1, klon
          pcfh(i,1) = cd_h(i)
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cltrac.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cltrac.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cltrac.F	(revision 634)
@@ -4,4 +4,5 @@
       SUBROUTINE cltrac(dtime,coef,t,tr,flux,paprs,pplay,delp,
      s                  d_tr)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -25,6 +26,6 @@
 c flux_tr--output-R- flux de tr
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
       REAL dtime
       REAL coef(klon,klev)
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cltracrn.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cltracrn.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cltracrn.F	(revision 634)
@@ -9,4 +9,5 @@
      s              d_tr,d_trs )
 
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -42,6 +43,6 @@
 c d_trs----output-R- le changement de "trs"
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "indicesol.h"
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/coefkzmin.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/coefkzmin.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/coefkzmin.F	(revision 634)
@@ -5,8 +5,9 @@
      .   ,km,kn)
 c      SUBROUTINE coefkzmin(ngrid,zlev,teta,ustar,km,kn)
+      USE dimphy
       IMPLICIT NONE
 
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 
@@ -59,6 +60,6 @@
 
       integer nlay,nlev
-      PARAMETER (nlay=klev)
-      PARAMETER (nlev=klev+1)
+cym      PARAMETER (nlay=klev)
+cym      PARAMETER (nlev=klev+1)
 
       integer ig,k
@@ -71,5 +72,6 @@
       real fl,zzz,zl0,zq2,zn2
 
-
+      nlay=klev
+      nlev=klev+1
 c.......................................................................
 c  en attendant une version ou les zlev, et zlay soient
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conccm.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conccm.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conccm.F	(revision 634)
@@ -5,4 +5,5 @@
      s                   d_t, d_q, rain, snow, kbascm, ktopcm)
 c
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -11,6 +12,6 @@
 c        (schema standard du modele NCAR CCM2)
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -143,4 +144,5 @@
      $                  tb, shb,
      $                  cmfprt, cmfprs, cnt, cnb)
+      USE dimphy
       IMPLICIT none
 C-----------------------------------------------------------------------
@@ -163,6 +165,6 @@
 c                    simplifier la lecture et la comprehension.
 C-----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
       INTEGER pcnst ! nombre de traceurs passifs
       PARAMETER (pcnst=1)
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/concvl.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/concvl.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/concvl.F	(revision 634)
@@ -12,4 +12,5 @@
  
 c
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -46,5 +47,5 @@
 c
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
 c
       integer NTRAC
@@ -82,6 +83,7 @@
        INTEGER i,k,itra
        REAL qs(klon,klev)
-       REAL cbmf(klon)
-       SAVE cbmf
+cym       REAL cbmf(klon)
+cym       SAVE cbmf
+       REAL,ALLOCATABLE,SAVE :: cbmf(:)
        INTEGER ifrst
        SAVE ifrst
@@ -97,4 +99,5 @@
       IF (ifrst .EQ. 0) THEN
          ifrst = 1
+	 allocate(cbmf(klon))
          DO i = 1, klon
           cbmf(i) = 0.
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conema3.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conema3.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conema3.F	(revision 634)
@@ -9,4 +9,5 @@
      .             qcond_incld)
 
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -54,5 +55,5 @@
 c
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
 #include "conema3.h"
       INTEGER i, l,m,itra
@@ -84,19 +85,31 @@
       REAL qcond_incld(klon,klev)
 c
-      REAL em_t(klev)
-      REAL em_q(klev)
-      REAL em_qs(klev)
-      REAL em_u(klev), em_v(klev), em_tra(klev,ntrac)
-      REAL em_ph(klev+1), em_p(klev)
-      REAL em_work1(klev), em_work2(klev)
-      REAL em_precip, em_d_t(klev), em_d_q(klev)
-      REAL em_d_u(klev), em_d_v(klev), em_d_tra(klev,ntrac)
-      REAL em_upwd(klev), em_dnwd(klev), em_dnwdbis(klev)
+      LOGICAL,SAVE :: first=.true.
+cym      REAL em_t(klev)
+      REAL,ALLOCATABLE,SAVE :: em_t(:)
+cym      REAL em_q(klev)
+      REAL,ALLOCATABLE,SAVE :: em_q(:)
+cym      REAL em_qs(klev)
+      REAL,ALLOCATABLE,SAVE :: em_qs(:)  
+cym      REAL em_u(klev), em_v(klev), em_tra(klev,ntrac)
+      REAL,ALLOCATABLE,SAVE :: em_u(:),em_v(:),em_tra(:,:)
+cym      REAL em_ph(klev+1), em_p(klev)
+      REAL,ALLOCATABLE,SAVE ::em_ph(:),em_p(:)
+cym      REAL em_work1(klev), em_work2(klev)
+      REAL,ALLOCATABLE,SAVE ::em_work1(:),em_work2(:)
+cym      REAL em_precip, em_d_t(klev), em_d_q(klev)
+      REAL,SAVE :: em_precip
+      REAL,ALLOCATABLE,SAVE :: em_d_t(:),em_d_q(:)
+cym      REAL em_d_u(klev), em_d_v(klev), em_d_tra(klev,ntrac)
+      REAL,ALLOCATABLE,SAVE ::em_d_u(:),em_d_v(:),em_d_tra(:,:)
+cym      REAL em_upwd(klev), em_dnwd(klev), em_dnwdbis(klev)
+      REAL,ALLOCATABLE,SAVE :: em_upwd(:),em_dnwd(:),em_dnwdbis(:)
       REAL em_dtvpdt1(klev), em_dtvpdq1(klev)
       REAL em_dplcldt, em_dplcldr
-      SAVE em_t,em_q, em_qs, em_ph, em_p, em_work1, em_work2
-      SAVE em_u,em_v, em_tra
-      SAVE em_d_u,em_d_v, em_d_tra
-      SAVE em_precip, em_d_t, em_d_q, em_upwd, em_dnwd, em_dnwdbis
+cym      SAVE em_t,em_q, em_qs, em_ph, em_p, em_work1, em_work2
+cym      SAVE em_u,em_v, em_tra
+cym      SAVE em_d_u,em_d_v, em_d_tra
+cym      SAVE em_precip, em_d_t, em_d_q, em_upwd, em_dnwd, em_dnwdbis
+
       INTEGER em_bas, em_top
       SAVE em_bas, em_top
@@ -113,12 +126,15 @@
 cccccccccccccccccccccccccccccccccccccccccccccccccc
  
-      REAL emmip(klev) !variation de flux ascnon dilue i et i+1
-      SAVE emmip
-      real emMke(klev)
-      save emMke
+cym      REAL emmip(klev) !variation de flux ascnon dilue i et i+1
+      REAL,ALLOCATABLE,SAVE ::emmip(:)
+cym      SAVE emmip
+cym      real emMke(klev)
+      REAL,ALLOCATABLE,SAVE ::emMke(:)
+cym      save emMke
       real top
       real bas
-      real emMa(klev)
-      save emMa
+cym      real emMa(klev)
+      REAL,ALLOCATABLE,SAVE ::emMa(:)
+cym      save emMa
       real Ma(klon,klev)
       real Ment(klev,klev)
@@ -151,5 +167,23 @@
 #include "YOETHF.h"
 #include "FCTTRE.h"
- 
+     
+      if (first) then
+  
+        allocate(em_t(klev))
+        allocate(em_q(klev))
+        allocate(em_qs(klev))
+        allocate(em_u(klev), em_v(klev), em_tra(klev,ntrac))
+        allocate(em_ph(klev+1), em_p(klev))
+        allocate(em_work1(klev), em_work2(klev))
+        allocate(em_d_t(klev), em_d_q(klev))
+        allocate(em_d_u(klev), em_d_v(klev), em_d_tra(klev,ntrac))
+        allocate(em_upwd(klev), em_dnwd(klev), em_dnwdbis(klev))
+        allocate(emmip(klev)) 
+	allocate(emMke(klev))
+        allocate(emMa(klev))
+  
+        first=.false.
+      endif
+  
       qcond_incld(:,:) = 0.
 c
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conemav.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conemav.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conemav.F	(revision 634)
@@ -9,4 +9,5 @@
  
 c
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -43,5 +44,5 @@
 c
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
 c
       integer NTRAC
@@ -73,6 +74,7 @@
        INTEGER i,k,itra
        REAL qs(klon,klev)
-       REAL cbmf(klon)
-       SAVE cbmf
+cym       REAL cbmf(klon)
+cym       SAVE cbmf
+       REAL,ALLOCATABLE,SAVE :: cbmf(:)
        INTEGER ifrst
        SAVE ifrst
@@ -85,4 +87,5 @@
       IF (ifrst .EQ. 0) THEN
          ifrst = 1
+	 allocate(cbmf(klon))
          DO i = 1, klon
           cbmf(i) = 0.
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conflx.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conflx.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conflx.F	(revision 634)
@@ -8,4 +8,5 @@
      s                   kcbot, kctop, kdtop, pmflxr, pmflxs)
 c
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -17,6 +18,6 @@
 c         et lessivage des traceurs passifs.
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -214,8 +215,9 @@
      .                   pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
      .                   dt_con, dq_con, pmflxr, pmflxs)
+      USE dimphy
       IMPLICIT none
 C     ------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -504,4 +506,5 @@
      .           pdmfdp, pmfu, pmfus, pmfuq, pdmfup, pdpmel, plu, plude,
      .           klab,pen_u, pde_u, pen_d, pde_d)
+      USE dimphy
       IMPLICIT none
 C----------------------------------------------------------------------
@@ -510,6 +513,6 @@
 C AND INITIALIZES VALUES FOR UPDRAFTS
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -629,4 +632,5 @@
       SUBROUTINE flxbase(ptenh, pqenh, pgeoh, paph,
      *     ptu, pqu, plu, ldcum, kcbot, klab)
+      USE dimphy
       IMPLICIT none
 C----------------------------------------------------------------------
@@ -641,6 +645,6 @@
 C (NON ENTRAINING PLUME,I.E.CONSTANT MASSFLUX)
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -714,4 +718,5 @@
      .     pmful, plude, pdmfup, kcbot, kctop, kctop0, kcum,
      .     pen_u, pde_u)
+      USE dimphy
       IMPLICIT none
 C----------------------------------------------------------------------
@@ -719,6 +724,6 @@
 C FOR CUMULUS PARAMETERIZATION
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1018,4 +1023,5 @@
      .  ,  pten, prfl, psfl, pdpmel, ktopm2
      .  ,  pmflxr, pmflxs)
+      USE dimphy
       IMPLICIT none
 C----------------------------------------------------------------------
@@ -1023,6 +1029,6 @@
 C FLUXES IN THE CLOUD LAYER AND IN THE SUBCLOUD LAYER
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1262,10 +1268,11 @@
      .  ,  pmfus, pmfds, pmfuq, pmfdq, pmful, pdmfup, pdmfdp
      .  ,  pdpmel, dt_con, dq_con)
+      USE dimphy
       IMPLICIT none
 c----------------------------------------------------------------------
 c calculer les tendances T et Q
 c----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1333,4 +1340,5 @@
      .     ldcum, kcbot, kctop, pmfub, prfl, ptd, pqd,
      .     pmfd, pmfds, pmfdq, pdmfdp, kdtop, lddraf)
+      USE dimphy
       IMPLICIT none
 C
@@ -1350,6 +1358,6 @@
 C MOIST ENVIRONMENTAL AIR AND CLOUD AIR.
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1444,4 +1452,5 @@
      .           ptd, pqd, pmfd, pmfds, pmfdq, pdmfdp,
      .           lddraf, pen_d, pde_d)
+      USE dimphy
       IMPLICIT none
 C
@@ -1461,6 +1470,6 @@
 C
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1559,4 +1568,5 @@
       END
       SUBROUTINE flxadjtq(pp, pt, pq, ldflag, kcall)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1568,6 +1578,6 @@
 C        kcall=2  EVAPORATION IN DOWNDRAFTS (E.G. CUDLFS,CUDDRAF)
 C
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 C
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conlmd.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conlmd.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conlmd.F	(revision 634)
@@ -4,4 +4,5 @@
       SUBROUTINE conlmd (dtime, paprs, pplay, t, q, conv_q,
      s                   d_t, d_q, rain, snow, ibas, itop)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -10,6 +11,6 @@
 c        Ajustement humide (Manabe) + Ajustement convectif (Kuo)
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -93,4 +94,5 @@
      s                   d_t, d_q, d_ql, rneb,
      s                   rain, snow, ibas, itop)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -105,6 +107,6 @@
 c du modele.
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -301,4 +303,5 @@
      s                    d_t, d_q, d_ql, rneb,
      s                    rain, snow, ibas, itop,accompli,imprim)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -309,6 +312,6 @@
 c        et itop est le haut du plus haut bloc
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -1064,4 +1067,5 @@
      s                  d_t, d_q, d_ql, rneb, 
      s                  rain, snow, ibas, itop)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1071,6 +1075,6 @@
 c N.B. version vectorielle (le 6 oct. 1997)
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -1587,4 +1591,5 @@
       END
       SUBROUTINE kuofcl(pt, pq, pg, pp, LDCUM, kcbot)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1603,6 +1608,6 @@
 c kcbot---output-I- Niveau du bas de la convection
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1688,4 +1693,5 @@
       END
       SUBROUTINE adjtq(pp, pt, pq, LDFLAG, KCALL)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1706,6 +1712,6 @@
 C        KCALL=2  EVAPORATION IN DOWNDRAFTS (E.G. CUDLFS,CUDDRAF)
 C
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 C
@@ -1797,10 +1803,11 @@
      .                 d_t, d_q, d_ql, rneb,
      .                 rain, snow, ibas, itop)
+      USE dimphy
       IMPLICIT NONE
 c
 c Ajustement humide (Schema de convection de Manabe)
 C.
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -2095,8 +2102,9 @@
      .                 d_t, d_q, d_ql,rneb,
      .                 rain, snow, ibas, itop)
+      USE dimphy
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/convect1.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/convect1.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/convect1.F	(revision 634)
@@ -107,8 +107,9 @@
 c
 c
+       USE dimphy
       implicit none
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 c
       integer len
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/convect2.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/convect2.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/convect2.F	(revision 634)
@@ -148,8 +148,9 @@
 c
 c
+      USE dimphy
       implicit none
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 c
       integer kmax2,imax2,kmin2,imin2
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/convect3.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/convect3.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/convect3.F	(revision 634)
@@ -18,6 +18,8 @@
 cFleur       Introduction des traceurs dans convect3 le 6 juin 200
 c#################################################################
+      USE dimphy
+
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
       PARAMETER (NA=60)
 
